#include <iostream>

using namespace std;

class Tootaja
{
public:
    virtual void tulumaks(int p) = 0;  ///pure virtual function

};
class Resident : public Tootaja
{
    void tulumaks(int p)  // override
    {
        int maks;
        if(p<=150)
            maks=0;
        else
            maks=(p-150)*0.2;
        cout<<"Resident "<<p<<" maks="<<maks<<endl;
    }
};
class Vooras : public Tootaja
{

    void tulumaks(int p)  // override
    {
        int maks = p * 0.16;

        cout<<"Vras "<<p<<" maks="<<maks<<endl;
    }

};
class Liitlane : public Tootaja
{
    void tulumaks(int p)  // override
    {
        int maks;
        if(p<=500)
            maks=0;
        else
            maks=(p-500)*0.3;
        cout<<"Liitlane "<<p<<" maks="<<maks<<endl;
    }
};
int main()
{
    Tootaja *t = new Resident();  // Upcasting
    t->tulumaks(250);  // Late Binding
    t->tulumaks(110);

    t = new Vooras();
    t->tulumaks(200);  // Late Binding
    t->tulumaks(100);

    t = new Liitlane();
    t->tulumaks(200);  // Late Binding
    t->tulumaks(1000);

   // t = new Tootaja();
    //t->tulumaks(33333);


    return 0;
}
